import { ComponentRender, IComponentEvents } from '@zeedhi/common';
import { IEventParam } from '@zeedhi/core';
import { ICalendar } from './common/ICalendar';

export class Calendar extends ComponentRender implements ICalendar {
  public events!: IComponentEvents<IEventParam<any>>;

  public cards?: Array<Object> = [];

  public types?: Array<Object> = [
    // 'month', 'week', 'day'
    {
      txt: 'Mês',
      val: 'month',
    },
    {
      txt: 'Semana',
      val: 'week',
    },
    {
      txt: 'Dia',
      val: 'day',
    },
  ];

  public defaultType = 'month';

  constructor(props: ICalendar) {
    super(props);
    this.createAccessors();
  }
}
